package com.boman.system.service;

import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.boman.domain.SysDept;
import com.boman.system.domain.vo.TreeSelect;

/**
 * 部门管理 服务层
 * 
 * @author ruoyi
 */
public interface ISysDeptService
{
    /**
     * 查询部门管理数据
     * 
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptList(SysDept dept);

    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDepts(SysDept dept);

    /**
     * 查询部门全部数据,不带权限
     * @return
     */
    public List<SysDept> selectDeptsList();

    /**
     * 构建前端所需要树结构
     * 
     * @param depts 部门列表
     * @return 树结构列表
     */
    public List<SysDept> buildDeptTree(List<SysDept> depts);

    /**
     * 构建前端所需要下拉树结构
     * 
     * @param depts 部门列表
     * @return 下拉树结构列表
     */
    public List<TreeSelect> buildDeptTreeSelect(List<SysDept> depts);

    /**
     * 根据角色ID查询部门树信息
     * 
     * @param roleId 角色ID
     * @return 选中部门列表
     */
    public List<Integer> selectDeptListByRoleId(Long roleId);

    /**
     * 根据部门ID查询信息
     * 
     * @param id 部门ID
     * @return 部门信息
     */
    public SysDept selectDeptById(Long id);

    /**
     * 根据部门名称查询信息
     * @param deptName
     * @return
     */
    public List<SysDept> selectByDeptName(String deptName);

    /**
     * 根据ID查询所有子部门（正常状态）
     * 
     * @param id 部门ID
     * @return 子部门数
     */
    public int selectNormalChildrenDeptById(Long id);

    /**
     * 是否存在部门子节点
     * 
     * @param id 部门ID
     * @return 结果
     */
    public boolean hasChildById(Long id);

    /**
     * 查询部门是否存在用户
     * 
     * @param id 部门ID
     * @return 结果 true 存在 false 不存在
     */
    public boolean checkDeptExistUser(Long id);

    /**
     * 校验部门名称是否唯一
     * 
     * @param dept 部门信息
     * @return 结果
     */
    public String checkDeptNameUnique(SysDept dept);

    /**
     * 新增保存部门信息
     * 
     * @param dept 部门信息
     * @return 结果
     */
    public int insertDept(SysDept dept);

    /**
     * 修改保存部门信息
     * 
     * @param dept 部门信息
     * @return 结果
     */
    public int updateDept(SysDept dept);

    /**
     * 删除部门管理信息
     * 
     * @param id 部门ID
     * @return 结果
     */
    public int deleteDeptById(Long id);

    /**
     * 功能描述: 根据deptId查找部门下的所有部门
     *
     * @param deptId deptId
     * @return com.boman.domain.dto.AjaxResult
     */
    List<SysDept> listChildrenDepts(Long deptId);

    List<SysDept> getByParentId(Long deptId);

    public List<JSONObject> syncData(int limit) throws Exception;

    /**
     * 功能描述: 只找父亲，不招爷爷
     *
     * @param parentId parentId
     * @return com.boman.domain.SysDept
     */
    SysDept getParentById(Long parentId);

    List<SysDept> listTowns(Long deptId);

    List<SysDept> selectByAreaId(String areaId);
}
